
/*==============================================================================
 *
 * (#)ScrollText.java
 * created         2003/02/07
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *==============================================================================
 */

package com.miami.romeo.main.about;

import javax.swing.*;
import javax.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

/* Package to play a mp3 sound track, no more used since release 0.1.2
import javazoom.jl.decoder.*;
import javazoom.jl.player.*;
*/

/**
 * ScrollText.<br>
 * This class creates a panel for the about box.
 *
 * @author       $Author: Stefano Bolli
 * @version      $Revision: 1.2 $Date: 2003/12/07 10:58:18 $
 */
public class ScrollText extends JPanel implements Runnable {

  /*
  // The sound track
  URL soundFile  = null;
  InputStream is = null;

  // The sound track player
  Player player = null;
  */

  // Lines
  String credits[] =  {
                       "Romeo - a java frontend for xmame",
		       " ",
                       "Programming:",
                       "                                        Stefano Bolli",
		       " ",
		       "Suggestions:",
                       "                                        Bruce Eckel",
                       "                                        James Goodwill",
                       "                                        Luigi Comi",
                       "                                        Naba Barkakati",
                       "                                        Shannon Dunn",
                       "                                        Brian D. Field",
                       "                                        Ivan Venuti",
                       "                                        Jeff Dinkins",
                       "                                        Steve Wilson",
                       "                                        Michael C. Albers",
                       "                                        Philip Milne",
                       "                                        Matt Segur",
                       "                                        Jeremy Cloud",
                       " ",
                       "Graphic:",
                       "                                        Stefano Bolli",
                       "                                        F. Amendolea",
                       "                                        Icons by Everaldo",
		       "                                        and Carlitus",
                       " ",
                       "Translations:",
                       "                                        Luis Oscar Villalvazo",
                       " ",
                       "Software Houses:",
                       "                                        Linux Mandrake",
                       "                                        Sun Microsystems",
                       "                                        l2fprod.com",
                       "                                        JavaMail Team",
                       "                                        The Gimp Team",
                       "                                        javazoom.com",
                       " ",
                       "Special Thanks To:",
                       "                                        Sandra",
                       "                                        Puccettone",
                       "                                        Adele",
                       "                                        Angelo",
                       "                                        Il Maialone",
                       "                                        Nunzia",
                       "                                        Massimo",
                       "                                        Teresa",
                       "                                        Giuseppe",
                       "                                        Lorenzo",
                       " ",
                       "That' s all, folks!",
                       " ",
                      };

  // Control scroll speed
  int delay   = 100,
      // Start position
      current = 230,
      // Spacing
      spacing = 20,
      // Animation height
      height  = 230;

  // Double buffering to eliminate frame flicker
  Image offImage;
  Graphics offGrfx;

  // Animation thread
  Thread runner;

  /*
  // Sound thread
  Thread sound;
  */

  /**
   * Constructor
   */
  public ScrollText() {
    setLayout(new BorderLayout());
  }

  public void paint(Graphics screen) {
    // Init buffer
    offImage = createImage(390, 230);
    offGrfx = offImage.getGraphics();

    // Clean previous image
    offGrfx.setColor(Color.black);
    offGrfx.fillRect(0, 0, 390, 230);

    offGrfx.setColor(Color.white);
    offGrfx.setFont(new Font("Arial", 0, 16));

    // Draw lines
    for (int i = 0; i < credits.length; i++) {
      offGrfx.drawString(credits[i], 20, current + (i * spacing));
    }

    // Flip buffer to the screen
    screen.drawImage(offImage, 0, 0, this);
  }

  public void update(Graphics screen) {
    // Override
    paint(screen);
  }

  /*
  public void start() {
    // Start animation
    if ((sound == null) && (runner == null)) {
      sound = new Thread() {
        public void run() {
          try {
            soundFile = getClass().getResource("/audio/soundtrack.mp3");
            is = soundFile.openStream();
            try {
              player = new Player(is);
              player.play();
            }
            catch (JavaLayerException jle) {
              System.err.println(jle.getMessage());
            }
          }
          catch (IOException ioe) {
            System.err.println(ioe.getMessage());
          }
        }
      };
      sound.start();


      runner = new Thread(this);
      runner.start();
    }
  }
  */

  public void start() {
    // Start animation
    if (runner == null) {
      runner = new Thread(this);
      runner.start();
    }
  }

  public void run() {
    while (true) {
      repaint();
      current--;
      if ((current + (credits.length * spacing)) < 0) {
        current = height + spacing;
      }

      try {
        Thread.sleep(delay);
      }
      catch (InterruptedException ie) {
      }
    }
  }

  /*
  public void stop() {
    // Stop thread
    if ((sound != null) && (runner != null)) {
      player.close();
      try {
        is.close();
      }
      catch (IOException ioe) {
        System.err.println(ioe.getMessage());
      }
      sound = null;
    }

    if (runner != null)
      runner = null;
    }
  }
  */

  public void stop() {
    // Stop thread
    if (runner != null)
      runner = null;
  }
}
